/*
**      Small-C Preprocessor Ver 1.0  - 01-Nov-87 - cpp.h
**
**      Copyright 1982, J. E. Hendrix
**
**      Macro Definitions
*/

/*      #include <stdio.h>    */

#define EOF       (-1)
#define BUFSIZ    256
#define NULL      0
#define FILE      char


/*
**      System wide name size (for symbols)
*/

#define NAMESIZE        9
#define NAMEMAX         8

/*
**      Maximum size of input line & output line
*/

#define LINEMAX         80
#define LINESIZE        81

/*
**      macro (define) pool
*/

#define MACNBR          200
#define MACNSIZE        (MACNBR * (NAMESIZE + 2))
#define MACNEND         (macn + MACNSIZE)
#define MACQSIZE        4500
#define MACMAX          (MACQSIZE - 1)

#define YES             1
#define NO              0

/*
**      variables
*/

extern char
        macn[MACNSIZE],         /* macro name buffer */
        macq[MACQSIZE],         /* macro string buffer */
        pline1[LINESIZE],       /* parsing buffer */
        pline2[LINESIZE],       /* parsing buffer */
        mline[LINESIZE],        /* macro buffer */
        *iline,                 /* points to a line buffer */
        *oline,                 /* points to a line buffer */
        *lptr,                  /* ptr to either */
        quote[2],               /* literal string for '"' */
        *cptr,                  /* work ptrs to any char buffer */
        *cptr2,
        *cptr3,
        msname[NAMESIZE],       /* macro symbol name array */
        ssname[NAMESIZE],       /* static symbol name array */
        xc,                     /* character workspace */
        *xcp;                   /* char pointer workspace */

extern int
        macptr,                 /* macro buffer index */
        ocount,                 /* count of output chars */
        ch,                     /* current character of line being scanned */
        nch,                    /* next character of line being scanned */
        iflevel,                /* #if... nest level */
        skiplevel,              /* level at which #if... skipping started */
        argstk,                 /* function argument sp */
        argtop,
        errflag,                /* non-zero after 1st error in statement */
        eof,                    /* set non-zero after final input eof */
        files,                  /* non-zero if filelist specified on cmdline*/
        filearg,                /* current file arg index */
        glbflag,                /* non-zero if internal globals */
        ccode,                  /* non-zero when parsing c-code */
                                /* zero when parsing assembly code */
        instring,               /* 1 if start of line within string */
        incomment,              /* 1 if start of line within comment */
        enstring,               /* 1 if end of line within string */
        encomment,              /* 1 if end of line within comment */
        ppline,                 /* 1 if line starts with #  */
        contin,                 /* 1 if a continuation */
        xi,                     /* integer workspace */
        *xip;                   /* int pointer workspace */

extern FILE
    **input,               /* ptr to input file ptr */
    *fileptr[12],          /* array of open fp's */
    *output,               /* file pointer for output file */
    *listfp;               /* file pointer to list device */

